/*
Child, Internet Relay Chat Services
Copyright (C) 2005-2009  David Lebrun (target0@geeknode.org)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/


#include <child.h>
#include <globals.h>

char *md5_hash(char *msg)
{
    EVP_MD_CTX mdctx;
    const EVP_MD *md;
    unsigned char md_value[EVP_MAX_MD_SIZE];
    int md_len,i;
    char *buf = (char *)malloc(EVP_MAX_MD_SIZE*sizeof(char));
    bzero(buf,EVP_MAX_MD_SIZE);

    OpenSSL_add_all_digests();

    md = EVP_get_digestbyname("md5");

    if (!md) {
        free(buf);
        return NULL;
    }

    EVP_MD_CTX_init(&mdctx);
    EVP_DigestInit_ex(&mdctx,md,NULL);
    EVP_DigestUpdate(&mdctx,msg,strlen(msg));
    EVP_DigestFinal_ex(&mdctx,md_value,&md_len);
    EVP_MD_CTX_cleanup(&mdctx);

    for (i=0;i<md_len;i++)
        sprintf(buf+i+i,"%02x",md_value[i]);

    return buf;
}
